package Msg

import (
	"context"

	"wechat-api/internal/svc"
	"wechat-api/internal/types"
	"wechat-api/internal/utils/dberrorhandler"


	"github.com/suyuan32/simple-admin-common/msg/errormsg"
	"github.com/zeromicro/go-zero/core/logx"
)

type UpdateMsgLogic struct {
	ctx    context.Context
	svcCtx *svc.ServiceContext
	logx.Logger
}

func NewUpdateMsgLogic(ctx context.Context, svcCtx *svc.ServiceContext) *UpdateMsgLogic {
	return &UpdateMsgLogic{
		ctx:    ctx,
		svcCtx: svcCtx,
		Logger: logx.WithContext(ctx),
	}
}

func (l *UpdateMsgLogic) UpdateMsg(req *types.MsgInfo) (*types.BaseMsgResp, error) {
    err := l.svcCtx.DB.Msg.UpdateOneID(*req.Id).
			SetNotNilStatus(req.Status).
			SetNotNilFromwxid(req.Fromwxid).
			SetNotNilToid(req.Toid).
			SetNotNilMsgtype(req.Msgtype).
			SetNotNilMsg(req.Msg).
			SetNotNilBatchNo(req.BatchNo).
			Exec(l.ctx)

    if err != nil {
		return nil, dberrorhandler.DefaultEntError(l.Logger, err, req)
	}

    return &types.BaseMsgResp{Msg: errormsg.UpdateSuccess}, nil
}
